/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Heap2.xs. Do not edit this file, edit Heap2.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Heap2.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

static int
cmp_nv (SV *a, SV *b, SV *data)
{
  if (SvROK (a) && SvTYPE (SvRV (a)) == SVt_PVAV) a = *av_fetch ((AV *)SvRV (a), 0, 1);
  if (SvROK (b) && SvTYPE (SvRV (b)) == SVt_PVAV) b = *av_fetch ((AV *)SvRV (b), 0, 1);

  return SvNV (a) > SvNV (b);
}

static int
cmp_sv (SV *a, SV *b, SV *data)
{
  if (SvROK (a) && SvTYPE (SvRV (a)) == SVt_PVAV) a = *av_fetch ((AV *)SvRV (a), 0, 1);
  if (SvROK (b) && SvTYPE (SvRV (b)) == SVt_PVAV) b = *av_fetch ((AV *)SvRV (b), 0, 1);

  return sv_cmp(a, b) > 0;
}

static int
cmp_custom (SV *a, SV *b, SV *data)
{
  SV *old_a, *old_b;
  int ret;
  dSP;

  if (!PL_firstgv)  PL_firstgv  = gv_fetchpv ("a", 1, SVt_PV);
  if (!PL_secondgv) PL_secondgv = gv_fetchpv ("b", 1, SVt_PV);

  old_a = GvSV (PL_firstgv);
  old_b = GvSV (PL_secondgv);

  GvSV (PL_firstgv)  = a;
  GvSV (PL_secondgv) = b;

  PUSHMARK (SP);
  PUTBACK;
  ret = call_sv (data, G_SCALAR | G_NOARGS | G_EVAL);
  SPAGAIN;

  GvSV (PL_firstgv)  = old_a;
  GvSV (PL_secondgv) = old_b;

  if (SvTRUE (ERRSV))
    croak (NULL);

  if (ret != 1)
    croak ("sort function must return exactly one return value");

  return POPi >= 0;
}

typedef int (*f_cmp)(SV *, SV *, SV *);

static AV *
array (SV *ref)
{
  if (SvROK (ref) && SvTYPE (SvRV (ref)) == SVt_PVAV)
    return (AV *)SvRV (ref);

  croak ("argument 'heap' must be an array");
}

#define geta(i) (*av_fetch (av, (i), 1))
#define gt(a,b) cmp ((a), (b), data)
#define seta(i,v) seta_helper (av_fetch (av, (i), 1), v)

static void
seta_helper (SV **i, SV *v)
{
  SvREFCNT_dec (*i);
  *i = v;
}

static void
push_heap_aux (AV *av, f_cmp cmp, SV *data, int hole_index, int top, SV *value)
{
  int parent = (hole_index - 1) / 2;

  while (hole_index > top && gt (geta (parent), value))
    {
      seta (hole_index, SvREFCNT_inc (geta (parent)));
      hole_index = parent;
      parent = (hole_index - 1) / 2;
    }

  seta (hole_index, value);
}

static void
adjust_heap (AV *av, f_cmp cmp, SV *data, int hole_index, int len, SV *elem)
{
  int top = hole_index;
  int second_child = 2 * (hole_index + 1);

  while (second_child < len)
    {
      if (gt (geta (second_child), geta (second_child - 1)))
        second_child--;

      seta (hole_index, SvREFCNT_inc (geta (second_child)));
      hole_index = second_child;
      second_child = 2 * (second_child + 1);
    }

  if (second_child == len)
    {
      seta (hole_index, SvREFCNT_inc (geta (second_child - 1)));
      hole_index = second_child - 1;
    }

  push_heap_aux (av, cmp, data, hole_index, top, elem);
}

static void
make_heap (AV *av, f_cmp cmp, SV *data)
{
  if (av_len (av) > 0)
    {
      int len = av_len (av) + 1;
      int parent = (len - 2) / 2;

      do {
          adjust_heap (av, cmp, data, parent, len, SvREFCNT_inc (geta (parent)));
      } while (parent--);
    }
}

static void
push_heap (AV *av, f_cmp cmp, SV *data, SV *elem)
{
  elem = newSVsv (elem);
  av_push (av, elem);
  push_heap_aux (av, cmp, data, av_len (av), 0, SvREFCNT_inc (elem));
}

static SV *
pop_heap (AV *av, f_cmp cmp, SV *data)
{
  if (av_len (av) < 0)
    return &PL_sv_undef;
  else if (av_len (av) == 0)
    return av_pop (av);
  else
    {
      SV *result = newSVsv (geta (0));
      SV *top = av_pop (av);

      adjust_heap (av, cmp, data, 0, av_len (av) + 1, top);

      return result;
    }
}

#line 168 "Heap2.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 312 "Heap2.c"

XS_EUPXS(XS_Array__Heap2_make_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap2_make_heap)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	heap = ST(0)
;
#line 165 "Heap2.xs"
        make_heap (array (heap), cmp_nv, 0);
#line 325 "Heap2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap2_make_heap_lex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap2_make_heap_lex)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	heap = ST(0)
;
#line 172 "Heap2.xs"
        make_heap (array (heap), cmp_sv, 0);
#line 342 "Heap2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap2_make_heap_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap2_make_heap_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cmp, heap");
    {
	SV *	cmp = ST(0)
;
	SV *	heap = ST(1)
;
#line 180 "Heap2.xs"
        make_heap (array (heap), cmp_custom, cmp);
#line 361 "Heap2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap2_push_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap2_push_heap)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "heap, ...");
    {
	SV *	heap = ST(0)
;
#line 187 "Heap2.xs"
        int i;
        for (i = 1; i < items; i++)
          push_heap (array (heap), cmp_nv, 0, ST(i));
#line 380 "Heap2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap2_push_heap_lex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap2_push_heap_lex)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "heap, ...");
    {
	SV *	heap = ST(0)
;
#line 196 "Heap2.xs"
        int i;
        for (i = 1; i < items; i++)
          push_heap (array (heap), cmp_sv, 0, ST(i));
#line 399 "Heap2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap2_push_heap_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap2_push_heap_cmp)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "cmp, heap, ...");
    {
	SV *	cmp = ST(0)
;
	SV *	heap = ST(1)
;
#line 206 "Heap2.xs"
        int i;
        for (i = 1; i < items; i++)
          push_heap (array (heap), cmp_custom, cmp, ST(i));
#line 420 "Heap2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap2_pop_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap2_pop_heap)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	heap = ST(0)
;
	SV *	RETVAL;
#line 215 "Heap2.xs"
        RETVAL = pop_heap (array (heap), cmp_nv, 0);
#line 438 "Heap2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Array__Heap2_pop_heap_lex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap2_pop_heap_lex)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	heap = ST(0)
;
	SV *	RETVAL;
#line 224 "Heap2.xs"
        RETVAL = pop_heap (array (heap), cmp_sv, 0);
#line 458 "Heap2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Array__Heap2_pop_heap_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap2_pop_heap_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cmp, heap");
    {
	SV *	cmp = ST(0)
;
	SV *	heap = ST(1)
;
	SV *	RETVAL;
#line 234 "Heap2.xs"
        RETVAL = pop_heap (array (heap), cmp_custom, cmp);
#line 480 "Heap2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Array__Heap2); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Array__Heap2)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Array::Heap2::make_heap", XS_Array__Heap2_make_heap, file, "\\@");
        (void)newXSproto_portable("Array::Heap2::make_heap_lex", XS_Array__Heap2_make_heap_lex, file, "\\@");
        (void)newXSproto_portable("Array::Heap2::make_heap_cmp", XS_Array__Heap2_make_heap_cmp, file, "&\\@");
        (void)newXSproto_portable("Array::Heap2::push_heap", XS_Array__Heap2_push_heap, file, "\\@@");
        (void)newXSproto_portable("Array::Heap2::push_heap_lex", XS_Array__Heap2_push_heap_lex, file, "\\@@");
        (void)newXSproto_portable("Array::Heap2::push_heap_cmp", XS_Array__Heap2_push_heap_cmp, file, "&\\@@");
        (void)newXSproto_portable("Array::Heap2::pop_heap", XS_Array__Heap2_pop_heap, file, "\\@");
        (void)newXSproto_portable("Array::Heap2::pop_heap_lex", XS_Array__Heap2_pop_heap_lex, file, "\\@");
        (void)newXSproto_portable("Array::Heap2::pop_heap_cmp", XS_Array__Heap2_pop_heap_cmp, file, "&\\@");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
